<template>
  <label
    class="ui-input-range"
    :class="classList"
  >
    <div class="range-wrapper">
      <div
        class="range"
        :style="rangeStyleList"
      >
        <div
          class="value"
          :class="`-${valueSide}`"
        >
          <slot
            name="value"
            :value="value"
            >{{ value }}</slot
          >
        </div>
      </div>
    </div>
    <input
      class="input flex-1"
      @input="handleInput"
      v-bind="inputProps"
      :disabled="isLoading"
      type="range"
    />
  </label>
</template>

<script lang="ts">
  import { computed, defineComponent } from 'vue'
  import get from 'lodash.get'
  import { computedEager } from '@vueuse/shared'

  export default defineComponent({
    name: 'ui-input-range',
    props: {
      value: {
        type: Number,
        default: 0,
      },
      min: {
        type: Number,
        default: 0,
      },
      max: {
        type: Number,
        default: Number.MAX_SAFE_INTEGER,
      },
      step: {
        type: Number,
        default: 1,
      },
      isLoading: {
        type: Boolean,
      },
    },
    emits: ['update:value'],
    setup(props, { emit }) {
      const percent = computed(() => (props.value - props.min) / (props.max - props.min))
      const classList = computedEager(() => (props.isLoading ? '-is-loading' : ''))
      const rangeStyleList = computed(() => ({
        transform: `translateX(${(percent.value - 1) * 100}%)`,
      }))
      const valueSide = computed(() => (percent.value > 0.5 ? 'left' : 'right'))

      const handleInput = (event: Event) => {
        emit('update:value', Number(get(event, ['target', 'value'], '0')))
      }

      const inputProps = computed(() => {
        return {
          value: props.value,
          min: props.min,
          max: props.max,
          step: props.step,
        }
      })

      return {
        handleInput,
        inputProps,
        rangeStyleList,
        valueSide,
        classList,
      }
    },
  })
</script>

<style>
  .ui-input-range {
    @apply uikit-block uikit-relative uikit-rounded-full uikit-top-0 uikit-w-full;

    --ui-input-range-height: 16px;
    height: var(--ui-input-range-height);
    background: rgb(64 231 255 / 20%);
  }

  .ui-input-range.-is-loading {
    @apply uikit-bg-gray-700 uikit-animate-pulse;
  }

  .ui-input-range > .range-wrapper {
    @apply uikit-overflow-hidden uikit-rounded-l-full uikit-absolute uikit-top-0 uikit-pointer-events-none uikit-select-none;
    height: var(--ui-input-range-height);
    width: calc(100% - 8px);
  }

  .ui-input-range > .range-wrapper > .range {
    @apply uikit-w-full uikit-relative uikit-pointer-events-none uikit-select-none;
    transform-origin: left center;
    height: var(--ui-input-range-height);
    background: #40e7ff;
  }

  .ui-input-range.-is-loading > .range-wrapper {
    @apply uikit-opacity-0;
  }

  .ui-input-range > .range-wrapper > .range > .value {
    @apply uikit-absolute uikit-top-0 uikit-font-title uikit-leading-none uikit-text-12 uikit-flex uikit-justify-center uikit-items-center uikit-pointer-events-none uikit-select-none uikit-whitespace-nowrap;
    height: var(--ui-input-range-height);
  }

  .ui-input-range > .range-wrapper > .range > .value.-left {
    @apply uikit-right-0 uikit-mr-8 uikit-text-black;
  }

  .ui-input-range > .range-wrapper > .range > .value.-right {
    @apply uikit-left-full uikit-ml-16 uikit-text-white;
  }

  .ui-input-range > .input {
    @apply uikit-absolute uikit-w-full;
    -webkit-appearance: none;
    width: 100%;
    background: transparent;
  }
  .ui-input-range > .input:focus {
    outline: none;
  }

  .ui-input-range > .input::-webkit-slider-thumb {
    @apply uikit-border-2 uikit-block uikit-w-8 uikit-left-full -uikit-top-4 uikit-rounded-full uikit-bg-black;
    height: calc(var(--ui-input-range-height) + 8px);

    box-shadow: inset 0px 0px 0 2px #fefefe;
    border: none;
    cursor: pointer;
    -webkit-appearance: none;
    margin-top: -4px;
  }

  .ui-input-range.-is-loading > .input::-webkit-slider-thumb {
    box-shadow: inset 0px 0px 0 2px theme('colors.gray.700');
    background: theme('colors.gray.700');
  }

  .ui-input-range > .input:focus::-webkit-slider-runnable-track,
  .ui-input-range > .input::-webkit-slider-runnable-track {
    background: transparent;
  }
  .ui-input-range > .input::-moz-range-track {
    width: 100%;
    height: 12.8px;
    cursor: pointer;
    animate: 0.2s;
    box-shadow: 0px 0px 0px #000000, 0px 0px 0px #0d0d0d;
    background: transparent;
    border-radius: 25px;
    border: 0px solid #000101;
  }
  .ui-input-range > .input::-moz-range-thumb {
    @apply uikit-border-2 uikit-block uikit-w-8 uikit-left-full -uikit-top-4 uikit-rounded-full uikit-bg-black;
    height: calc(var(--ui-input-range-height) + 8px);
    box-shadow: inset 0px 0px 0 2px #fefefe;

    border: 0px solid #000000;
    cursor: pointer;
  }
  .ui-input-range > .input::-ms-track {
    width: 100%;
    height: 12.8px;
    cursor: pointer;
    animate: 0.2s;
    background: transparent;
    uikit-border-color: transparent;
    uikit-border-width: 39px 0;
    color: transparent;
  }
  .ui-input-range > .input::-ms-fill-lower {
    background: transparent;
    border: 0px solid #000101;
    border-radius: 50px;
    box-shadow: 0px 0px 0px #000000, 0px 0px 0px #0d0d0d;
  }
  .ui-input-range > .input::-ms-fill-upper {
    background: transparent;
    border: 0px solid #000101;
    border-radius: 50px;
    box-shadow: 0px 0px 0px #000000, 0px 0px 0px #0d0d0d;
  }
  .ui-input-range > .input::-ms-thumb {
    @apply uikit-border-2 uikit-block uikit-w-8 uikit-left-full -uikit-top-4 uikit-rounded-full uikit-bg-black;
    height: calc(var(--ui-input-range-height) + 8px);
    box-shadow: inset 0px 0px 0 2px #fefefe;

    border: 0px solid #000000;
    cursor: pointer;
  }
  .ui-input-range > .input:focus::-ms-fill-lower {
    background: transparent;
  }
  .ui-input-range > .input:focus::-ms-fill-upper {
    background: transparent;
  }
</style>
